<?php

require_once("binary.php");

function convbpp($s){
   $t="";
   for($i=0;$i<strlen($s);$i++){
      $ch=ord($s[$i]);
      $ch1=$ch>>4; $ch2=$ch&15;
      $ch1=(($ch1&12)<<2)|($ch1&3);
      $ch2=(($ch2&12)<<2)|($ch2&3);
      $t.=chr($ch1).chr($ch2);
   }
   return $t;
}

function write_bmp($fn,$wh,$hh,$dt,$pal,$bpp,$sl,$whb,$brev=false){
   if($bpp==2){
      $dt=convbpp($dt); $whb<<=1; $bpp=4;
      $pal.=str_repeat("\x00",48);
   }
      $wb=(($wh*$bpp+31)&~31)>>3; $ls=(($wh*$bpp+7)&~7)>>3;
      $pl=($bpp<=8)?(4<<$bpp):0;
      $s="BM";
      $s.=int42str(0x36+$wb*$hh+$pl);
      $s.="\x00\x00\x00\x00";
      $s.=int42str(0x36+$pl);
      $s.="\x28\x00\x00\x00";
      $s.=int42str($wh);
      $s.=int42str($hh);
      $s.="\x01\x00";
      $s.=int22str($bpp);
      $s.="\x00\x00\x00\x00";
      $s.=int42str($wb*$hh);
      $s.="\xC4\x0E\x00\x00";
      $s.="\xC4\x0E\x00\x00";
      $s.="\x00\x00\x00\x00";
      $s.="\x00\x00\x00\x00";
            $pal=str_pad($pal,$pl,"\x00");
      $s.=substr($pal,0,$pl);
      $pd=str_repeat("\x00",$wb-$ls);
$bypp=(int)ceil($bpp/8);
$whp=(int)($whb/$bypp);
      for($i=0;$i<$hh;$i++){
         if($sl and $bpp>8){
            for($j=0;$j<$whp;$j++){
               for($p=$bypp-1;$p>=0;$p--){
                  $s.=substr($dt,$whb*($hh-$i-1)+$j+$p*$wh,1);
               }
            }
         }else{
            if($bpp>8 and $brev){
               for($j=0;$j<$wh;$j++){
                  $s.=strrev(substr($dt,$whb*($hh-$i-1)+$j*$bypp,$bypp));
               }
            }else{
               $s.=substr($dt,$whb*($hh-$i-1),$ls);
            }
         }
         $s.=$pd;
      }
      $fp_out=fopen($fn,"wb");
      fwrite($fp_out,$s);
      fclose($fp_out);
}
?>
